| D++ (DPP) C++ Discord API Bot Library

Search
Loading...
Searching...
No Matches
dpp::command_option_choice Struct Reference

This struct represents choices in a multiple choice option for a command parameter. It has both a string name, and a value parameter which is a variant, meaning it can hold different potential types (see dpp::command_value) that you can retrieve with std::get(). More...

`#include <appcommand.h>`

Inheritance diagram for dpp::command_option_choice:
[legend]
Collaboration diagram for dpp::command_option_choice:
[legend]

## Public Member Functions

| command_option_choice ()=default
| Construct a new command option choice object.
| command_option_choice (const std::string &n, command_value v)
| Construct a new command option choice object.
virtual | ~command_option_choice ()=default
command_option_choice & | add_localization (const std::string &language, const std::string &_name)
| Add a localisation for this command option choice.
std::string | build_json (bool with_id=false) const
| Convert object to json string.
command_option_choice & | fill_from_json (nlohmann::json *j)
| Convert object from nlohmann::json.
auto | to_json (bool with_id=false) const
| Convert object to nlohmann::json.

## Public Attributes

std::string | name
| Option name (1-32 chars).
std::map< std::string, std::string > | name_localizations
| Localisations of command option name.
command_value | value
| Option value.

## Protected Member Functions

command_option_choice & | fill_from_json_impl (nlohmann::json *j)
| Fill object properties from JSON.

## Friends

struct | json_interface< command_option_choice >

## Detailed Description

This struct represents choices in a multiple choice option for a command parameter. It has both a string name, and a value parameter which is a variant, meaning it can hold different potential types (see dpp::command_value) that you can retrieve with std::get().

## Constructor & Destructor Documentation

## ◆ command_option_choice() [1/2]

dpp::command_option_choice::command_option_choice | ( |  | ) |

default

Construct a new command option choice object.

## ◆ ~command_option_choice()

virtual dpp::command_option_choice::~command_option_choice | ( |  | ) |

virtual default

## ◆ command_option_choice() [2/2]

dpp::command_option_choice::command_option_choice | ( | const std::string & | n,
|  | command_value | v )

Construct a new command option choice object.

Parameters

  n | name to initialise with
  v | value to initialise with

## Member Function Documentation

## ◆ add_localization()

command_option_choice & dpp::command_option_choice::add_localization | ( | const std::string & | language,
|  | const std::string & | _name )

Add a localisation for this command option choice.

See also
  https://discord.com/developers/docs/reference#locales

Parameters

  language | Name of language, see the list of locales linked to above
  _name | name of command option choice in the specified language

Returns
  command_option_choice& reference to self for fluent chaining

## ◆ build_json()

std::string dpp::json_interface< command_option_choice >::build_json | ( | bool | with_id = false | ) | const

inline inherited

Convert object to json string.

Parameters

  with_id | Whether to include the ID or not

Note
  Some fields are conditionally filled, do not rely on all fields being present

Returns
  std::string Json built from the structure

## ◆ fill_from_json()

command_option_choice & dpp::json_interface< command_option_choice >::fill_from_json | ( | nlohmann::json * | j | ) |

inline inherited

Convert object from nlohmann::json.

Parameters

  j | nlohmann::json object

Returns
  T& Reference to self for fluent calling

## ◆ fill_from_json_impl()

command_option_choice & dpp::command_option_choice::fill_from_json_impl | ( | nlohmann::json * | j | ) |

protected

Fill object properties from JSON.

Parameters

  j | JSON to fill from

Returns
  command_option_choice& Reference to self

## ◆ to_json()

auto dpp::json_interface< command_option_choice >::to_json | ( | bool | with_id = false | ) | const

inline inherited

Convert object to nlohmann::json.

Parameters

  with_id | Whether to include the ID or not

Note
  Some fields are conditionally filled, do not rely on all fields being present

Returns
  json Json built from the structure

## Friends And Related Symbol Documentation

## ◆ json_interface< command_option_choice >

friend struct json_interface< command_option_choice >

friend

## Member Data Documentation

## ◆ name

std::string dpp::command_option_choice::name

Option name (1-32 chars).

## ◆ name_localizations

std::map<std::string, std::string> dpp::command_option_choice::name_localizations

Localisations of command option name.

## ◆ value

command_value dpp::command_option_choice::value

Option value.

D++ Library version 9.0.13 D++ Library version 9.0.12 D++ Library version 9.0.11 D++ Library version 9.0.10 D++ Library version 9.0.9 D++ Library version 9.0.8 D++ Library version 9.0.7 D++ Library version 9.0.6 D++ Library version 9.0.5 D++ Library version 9.0.4 D++ Library version 9.0.3 D++ Library version 9.0.2 D++ Library version 9.0.1 D++ Library version 9.0.0 D++ Library version 1.0.2 D++ Library version 1.0.1 D++ Library version 1.0.0